# Flrouter
[![pub package](https://img.shields.io/pub/v/flrouter.svg)](https://pub.dartlang.org/packages/flrouter)

Flrouter is a Flutter routing library that adds flexible routing options like parameters and clear route definitions.

## Usage
To use this plugin, add `flrouter` as a [dependency in your pubspec.yaml file](https://flutter.io/platform-plugins/).

## Usage
``` dart
// Import package
import 'package:flrouter/flrouter.dart';
```

``` dart
Flrouter.instance.definitions({
  '/accounts/{id}': (context, match) {
    return Accounts.View(id: match.parameters['id']);
  },
  '/': (context, match) {
    return Index();
  },
});

// OR

Flrouter.instance.define('/accounts/{id}', build: (context, match) {
  return Accounts.View(id: match.parameters['id']);
});

Flrouter.instance.define('/', build: (context, match) {
  return Index();
});
```

``` dart
runApp(MaterialApp(
  onGenerateRoute: Flrouter.instance.generator,
));
```
