library flrouter;

import 'package:flutter/material.dart';
import 'package:uri/uri.dart';

typedef Widget FlrouterBuilder(BuildContext context, UriMatch match);

class Flrouter {
  static final instance = Flrouter();

  void define(final String route, {@required final FlrouterBuilder builder}) {
    _definitions.putIfAbsent(route, () => builder);
  }

  void definitions(final Map<String, FlrouterBuilder> definitions) {
    this._definitions.addAll(definitions);
  }

  Route<dynamic> generator(final RouteSettings settings) {
    final route = this._definitions.keys.where((route) => UriParser(UriTemplate(route)).matches(Uri.parse(settings.name))).first;
    
    return MaterialPageRoute(settings: settings, builder: (context)=> this._definitions[route](context, UriParser(UriTemplate(route)).match(Uri.parse(settings.name))));
  }

  final _definitions = Map<String, FlrouterBuilder>();
}